# generate genotype data for multiple families

generateG <- function(nfam, pedstr, alfreqforfdr, latcorrmatforfdr)
{
  # generate G
  fdr.ic <- (pedstr[, 2] == 0) & (pedstr[, 3] == 0)
  nfdr <- sum(fdr.ic)
  nsnp <- length(alfreqforfdr)
  G <- vector("list", nfam)
  G.fdr <- vector("list", nfam)
  flag.dupl <- T
  flag.mono <- T
  while(flag.dupl)
  {
    while(flag.mono)
    {
      for (i in 1 : nfam)
      {
        G.fdr[[i]] <- generatefdrG(nfdr, alfreqforfdr, latcorrmatforfdr)
      }
      G.fdr.all <- do.call(rbind, G.fdr)
      flag.mono = (sum(colMeans(G.fdr.all) != 0 & colMeans(G.fdr.all) != 1) != nsnp)
    }
    for (i in 1 : nfam)
    {
      G[[i]] <- generatepedG(pedstr, G.fdr[[i]])
    }
    G.all <- do.call(rbind, G)
    flag.dupl <- (anyDuplicated(G.all, MARGIN = 2) > 0)
  }
  
  return(G.all)
}
